/usr/bin/clevis-decrypt-http is in clevis 8-1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 | #!/bin/bash -e
# vim: set tabstop=8 shiftwidth=4 softtabstop=4 expandtab smarttab colorcolumn=80:
#
# Copyright (c) 2017 Red Hat, Inc.
# Author: Nathaniel McCallum <npmccallum@redhat.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#
[ $# -eq 1 -a "$1" == "--summary" ] && exit 1
if [ -t 0 ]; then
echo >&2
echo "Usage: clevis decrypt http < JWE > PLAINTEXT" >&2
echo >&2
exit 1
fi
read -d . hdr
if [ "`jose fmt -q "$hdr" -SyOg clevis -g pin -u-`" != "http" ]; then
echo "JWE pin mismatch!" >&2
exit 1
fi
if ! url=`jose fmt -q "$hdr" -SyOg clevis -g http -g url -u-`; then
echo "JWE missing 'clevis.http.url' header parameter!" >&2
exit 1
fi
if ! typ=`jose fmt -q "$hdr" -SyOg clevis -g http -g type -u-`; then
echo "JWE missing 'clevis.http.url' header parameter!" >&2
exit 1
fi
if ! rep=`curl -sfg -H "Accept: $typ" "$url"`; then
echo "Key transfer failed!" >&2
exit 1
fi
case $typ in
application/jwk+json)
if ! rep=`curl -sfg -H "Accept: $typ" "$url" \
| jose fmt -j- -Og kty -q oct -EUUo-`; then
echo "Key transfer failed!" >&2
exit 1
fi
;;
application/octet-stream)
if ! key=`curl -sfg -H "Accept: $typ" "$url" | jose b64 enc -I-`; then
echo "Key transfer failed!" >&2
exit 1
fi
jwk="{\"kty\":\"oct\",\"k\":\"$key\"}"
;;
esac
exec jose jwe dec -k- -i- < <(echo -n "$jwk$hdr."; cat)
|